﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AsyncAwait
{
    class Program
    {
        /*
        static void Main(string[] args)
        {
            //czynność
            Func<object, long> akcja =
                (object argument) =>
                {
                    Console.WriteLine("Początek działania akcji - " + argument.ToString());
                    System.Threading.Thread.Sleep(500);
                    Console.WriteLine("Koniec działania akcji - " + argument.ToString());
                    return DateTime.Now.Ticks;
                };

            //long wynik = akcja("synchronicznie");
            //Console.WriteLine("S: " + wynik.ToString());

            //uruchomienie w osobnym zadaniu
            Task<long> zadanie = new Task<long>(akcja, "zadania");
            zadanie.Start();
            Console.WriteLine("Akcja została uruchomiona");
            long wynik = zadanie.Result;
            Console.WriteLine("Zadanie: " + wynik.ToString());
        }
        */

        private static Task<long> zróbCośAsync(object argument)
        {
            //czynność
            Func<object, long> akcja =
                (object _argument) =>
                {
                    Console.WriteLine("Początek działania akcji - " + _argument.ToString());
                    System.Threading.Thread.Sleep(500);
                    Console.WriteLine("Koniec działania akcji - " + _argument.ToString());
                    return DateTime.Now.Ticks;
                };

            //long wynik = akcja("synchronicznie");
            //Console.WriteLine("S: " + wynik.ToString());

            //uruchomienie w osobnym zadaniu
            Task<long> zadanie = new Task<long>(akcja, argument);
            zadanie.Start();
            return zadanie;
        }

        static async void programowanieAsynchroniczne()
        {
            Task<long> zadanie2 = zróbCośAsync("zadanie-metoda");
            Console.WriteLine("Akcja została uruchomiona");
            long wynik = await zadanie2;
            Console.WriteLine("Zadanie: " + wynik.ToString());
        }

        static void Main(string[] args)
        {
            programowanieAsynchroniczne();
            Console.Write("\nNaciśnij Enter..."); Console.ReadLine();
        }

    }
}
